﻿@using ASP.NET_MVC5_WebShopExample.Models.ViewModels;
@model ImageEditViewModel

@{ 
    var action = ViewContext.RouteData.Values["action"] as string;
    var controller = ViewContext.RouteData.Values["controller"] as string;
    var isRouteContainImageId = ViewContext.RouteData.Values.ContainsKey("id");
}

@using (Html.BeginForm(action, controller,
    FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()


<div class="form-horizontal">
    <h4>Image</h4>
    <hr />

    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.Hidden("ownerId", Model.OwnerId)

    @if (Model.BackUrl != null)
    {
        @Html.Hidden("backUrl", Model.BackUrl)
    }
    @if (Model.Image.ImageId != default(int))
    {
        @Html.HiddenFor(model => model.Image.ImageId);
        if (isRouteContainImageId)
        {
            var src = Url.Action("GetImage", new { id = Model.Image.ImageId });
            var width = 256;
            var height = Model.Image.Height * (width / Model.Image.Width);
            <div class="form-group">
                <label class="control-label col-md-2">Image</label>
                <div class="col-md-10">
                    <a href="@src" target="_blank" title="open image in new tab">
                    <img class="img-thumbnail" src="@src" alt="@Model.Image.Name" width="@width" height="@height" />
                    </a>
                </div>
            </div>
        }
    }

    <div class="form-group">
        @Html.LabelFor(model => model.Image.Name, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Image.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Image.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Image.Description, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Image.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Image.Description, "", new { @class = "text-danger" })
        </div>
    </div>
    @if (isRouteContainImageId)
    {
        var uploadUserEmail = Model.Image.UploadedByUser.Email;
        <div class="form-group">
            <label class="control-label col-md-2">Uploaded by</label>
            <div class="col-md-10 form-group__view-data">
                <a href="mailto:@uploadUserEmail" target="_blank">@uploadUserEmail</a>
            </div>
        </div>
        <div class="form-group">
            <label class="control-label col-md-2">@Html.DisplayNameFor(model => model.Image.UploadedDate)</label>
            <div class="col-md-10 form-group__view-data">
                @Html.DisplayFor(model => model.Image.UploadedDate)
            </div>
        </div>
    }
    <div class="form-group">
        @{ var postedFile = "postedFile"; }
        @Html.Label(postedFile, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            <input type="file" id="@postedFile" name="@postedFile" accept="image/*" class="form-control" />
            @Html.ValidationMessage(postedFile, Model.ImageServerError, new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            @{
                var btnSubmitText = action[0].ToString().ToUpper() + action.Substring(1);
            }
            <input type="submit" value="@btnSubmitText" class="btn btn-primary" />
            @if (Model.BackUrl != null)
            {
                <a class="btn btn-default" href="@Model.BackUrl">Back</a>
            }
        </div>
    </div>
</div>
}